﻿* Encoding: UTF-8.
*Fit covariates
*SPSS macros by Kirill Orlov
*kior@comtv.ru, ttnphns@gmail.com
*https://www.spsstools.net/en/KO-spssmacros
*All rights reserved.

*/*!KO_FITCOV*/*******************************************************************************.
define !KO_fitcov(vars= !charend('/') /matrix= !charend('/') /method= !charend('/') /adjust= !charend('/') /iter= !charend('/') /msave= !charend('/'))
!if (!iter=!null !and !method<>'QUICK' !or !method<>'IREGR' !and !method<>'IPCOMP' !and !method<>'QUICK') !then
-do if $casenum=1.
-print /'>ERROR. Неверно задано METHOD или ITER.'.
-end if.
-exec.
!else
-set mxloops 10000.
-matrix.
-comp ok= 1.
-get mx /file= !matrix /names= cnam.
-comp rowtype= mx(:,1).
-comp mx= mx(:,3:ncol(mx)).
-comp vec1= make(1,ncol(mx),0).
-comp vec2= make(1,ncol(mx),0).
-comp rowtype= {rowtype;rowtype(nrow(rowtype))}.
-do if rowtype(3)='COV'.
- do if any(rowtype(1)={'MIN','MAX','MEAN'}) and rowtype(2)= 'COV'.
-  comp vec1= mx(1,:).
-  comp mx= mx(2:nrow(mx),:).
- else if rowtype(1)<>'COV'.
-  comp ok= 0.
-  print /title '>ERROR. В матрице есть векторы неразрешенных для COV статистик.'.
- end if.
-else if rowtype(3)='CORR'.
- do if any(rowtype(1)={'MIN','MAX','MEAN'}).
-  comp vec1= mx(1,:).
- else if rowtype(1)<>'CORR'.
-  comp ok= 0.
-  print /title '>ERROR. В матрице 1-й вектор статистик неправилен для CORR.'.
- end if.
- do if any(rowtype(2)={'MAX','MEAN','STDDEV','SD'}) and rowtype(2)<>rowtype(1).
-  comp vec2= mx(2,:).
-  comp mx= mx(3:nrow(mx),:).
- else if rowtype(1)<>'CORR'.
-  comp ok= 0.
-  print /title '>ERROR. В матрице 2-й вектор статистик отсутствует или неправилен для CORR.'.
- end if.
-else if rowtype(1)<>'SSCP' and rowtype(1)<>'MSCP'.
- comp ok= 0.
- print /title '>ERROR. В матрице есть векторы неразрешенных статистик, или тип матрицы неясен.'.
-end if.
-do if ok.
- print rowtype(3) /title 'Тип целевой матрицы:' /format= a8.
- get vars /vari= !vars /names= vnam /miss= 0.
  !if (!vars='ALL' !or !vars='all') !then
-  do if ncol(vars)<>ncol(mx).
-   print /title '>ERROR. VARS=ALL, но число переменных и число столбцов матрицы не совпадают.'.
-  else.
  !else
-  comp ind= 0.
-  loop i= 1 to ncol(vnam).
-   loop i2= 3 to ncol(cnam).
-    do if cnam(i2)=vnam(i).
-     comp ind= {ind,i2}.
-     break.
-    end if.
-   end loop.
-  end loop if i2=ncol(cnam)+1.
-  do if i2=ncol(cnam)+1.
-   print /title '>ERROR. Имена некоторых VARS отсутствуют среди столбцов матрицы.'.
-  else.
-   comp ind= ind(2:ncol(ind))-2.
-   comp mx= mx(ind,ind).
-   comp vec1= vec1(ind). 
-   comp vec2= vec2(ind). 
-   release ind.
  !ifend
-   do if any(mx<>t(mx)).
-    print /title '>ERROR. Целевая матрица не симметрическая.'.
-   else if any(eval(mx)<0).
-    print /title '>ERROR. Целевая матрица не грамова.'.
-   else if det(mx)=0.
-    print /title '>ERROR. Целевая матрица вырождена.'.
-   else if rowtype(3)='CORR' and any(diag(mx)<>1).
-    print /title '>ERROR. Целевая CORR матрица имеет диагональный элемент не равный 1.'.
-   else.
-    comp n= nrow(vars).
-    do if rowtype(3)='CORR' or rowtype(3)='COV'.
-     comp df= n-1.
-    else if rowtype(3)='MSCP'.
-     comp df= n.
-    else.
-     comp df= 1.
-    end if.
-    comp mx= mx*df.
-    do if rowtype(3)='CORR' or rowtype(3)='COV'.
-     comp vars= vars-kroneker(csum(vars)/n,make(n,1,1)).
-    end if.
-    comp vars= vars&*kroneker(sqrt(t(diag(mx))/cssq(vars)),make(n,1,1)).
     !if (!method='QUICK') !then
-     call eigen(mx,eivec,eival).
-     call eigen(sscp(vars),eivec_,eival_).
-     comp vars= vars*inv(t(eivec_)).
-     comp vars= vars&*kroneker(t(sqrt(eival/eival_)),make(n,1,1)).
-     comp vars= vars*t(eivec).
     !else
      !if (!method='IPCOMP') !then !let !ss= 'eival(i)'
-      call eigen(mx,eivec,eival).
-      comp vars= vars*inv(t(eivec)).
       !if (!adjust='HSCED1' !or !adjust='HSCED2') !then
-       comp vars(:,1)= vars(:,1)-csum(vars(:,1))/n.
       !ifend
-      comp vars(:,1)= vars(:,1)*sqrt(eival(1)/cssq(vars(:,1))).
      !ifend
      !if (!tail(!iter)=!null) !then !let !inc= 0 !else !let !inc= !tail(!iter) !ifend
-     loop i= 2 to ncol(vars).
-      comp j= i-1.
       !if (!method='IREGR') !then !let !ss= 'ss'
-       comp b= inv(mx(1:j,1:j))*mx(1:j,i).
-       comp pre= vars(:,1:j)*b.
-       comp vars(:,i)= vars(:,i)-pre.
-       comp ss= mx(i,i)-cssq(pre).
        !if (!adjust='HSCED1' !or !adjust='HSCED2') !then !let !abs= 'abs' !let !sign= 'comp s= (vars(:,i)>=0)-(vars(:,i)<0)' !let !hsced= '+s&*rsum(c_&*vars_&**3/vcss_)' !let !vrss_= '+vrss_'
-        comp vars_= vars(:,1:j)-kroneker(csum(vars(:,1:j))/n,make(n,1,1)).
         !if (!adjust='HSCED2') !then
-         comp vars_= abs(vars_)-kroneker(csum(abs(vars_))/n,make(n,1,1)).
         !ifend
        !ifend
       !else
        !if (!adjust='HSCED1' !or !adjust='HSCED2') !then !let !hsced= '+rsum(c_&*vars_&**3/vcss_)' !let !vrss_= '+vrss_'
-        comp vars_= abs(vars(:,1:j)).
         !if (!adjust='HSCED2') !then !let !abs= 'abs' !let !sign= 'comp s= (vars(:,i)>=0)-(vars(:,i)<0)' !let !hsced= '+s&*rsum(c_&*vars_&**3/vcss_)'
-         comp vars_= vars_-kroneker(csum(vars_)/n,make(n,1,1)).
         !ifend
        !ifend
       !ifend
-      comp vrss= rssq(vars(:,1:j)).
       !if (!adjust<>'NONE') !then
-       comp vcss= kroneker(cssq(vars(:,1:j)),make(n,1,1)).
       !ifend
       !if (!adjust='HSCED1' !or !adjust='HSCED2') !then
-       comp vrss_= rssq(vars_).
-       comp vcss_= kroneker(cssq(vars_),make(n,1,1)).
       !ifend
-      comp vrss= vrss+((vrss!vrss_)=0).
-      loop i2= 1 to !head(!iter)+!inc*(i-2).
        !if (!adjust<>'NONE') !then
-        comp vars(:,i)= vars(:,i)-csum(vars(:,i))/n.
        !ifend
-       comp c= kroneker(t(vars(:,i))*vars(:,1:j),make(n,1,1)).
        !if (!adjust='HSCED1' !or !adjust='HSCED2') !then
-        comp c_= kroneker(t(!abs(vars(:,i)))*vars_,make(n,1,1)).
        !ifend
        !if (!adjust='NONE') !then
-        comp vars(:,i)= vars(:,i)-rsum(c&*vars(:,1:j))/n/vrss.
        !else
-        !sign.
-        comp vars(:,i)= vars(:,i)-(rsum(c&*vars(:,1:j)&**3/vcss)!hsced)/(vrss!vrss_).
        !ifend
-       comp vars(:,i)= vars(:,i)*sqrt(!ss/cssq(vars(:,i))).
-      end loop.
       !if (!method='IREGR') !then
-       comp vars(:,i)= pre+vars(:,i).
       !ifend
-     end loop.
      !if (!method='IPCOMP') !then
-      comp vars= vars*t(eivec).
      !ifend
-     release c.
      !if (!adjust<>'NONE') !then
-      release vcss.
      !ifend
      !if (!adjust='HSCED1' !or !adjust='HSCED2') !then
-      release vars_,vcss_,c_.
      !ifend
-     do if rowtype(3)='CORR' or rowtype(3)='COV'.
-      comp vars= vars-kroneker(csum(vars)/n,make(n,1,1)).
-     end if.
-     comp vars= vars&*kroneker(sqrt(t(diag(mx))/cssq(vars)),make(n,1,1)).
-     comp vcs= kroneker(csum(vars),make(nrow(mx),1,1)).
-     comp num= mx*n-vcs&*t(vcs).
-     comp den= kroneker(diag(num),make(1,ncol(mx),1)).
-     comp mx= num/sqrt(den&*t(den)).
-     comp num= sscp(vars)*n-vcs&*t(vcs).
-     comp mx= abs(mx-num/sqrt(den&*t(den))).
-     comp dcrfit= 0.
-     loop i= 2 to ncol(mx).
-      comp dcrfit= {dcrfit;msum(mx(1:(i-1),i))/(i-1)}.
-     end loop.
-     print (msum(mx)/(ncol(mx)*(ncol(mx)-1))) /title 'Общая недостигнутость целевой матрицы:' /format= f20.15.
-     print /title 'AllPre - Средняя недостигнутость в отношениях с предшествующими переменными:'.
-     print {dcrfit,rmax(mx)} /title 'MaxAll - Максимальная постолбцовая недостигнутость целевой матрицы:' /rnames= vnam /clabels= 'AllPre' 'MaxAll' /format= f18.15 /space= 0.
     !ifend
     !if (!msave<>!null) !then !let !mscmd= !conc('save {rowtype((nrow(rowtype)-nrow(mx)):(nrow(rowtype)-1)),t(vnam),mx} /outfile=',!msave,' /names= cnam /strings= rowtype_ varname_')
-     comp mx= sscp(vars)/df.
-     comp cnam= {'rowtype_','varname_',vnam}.
-     print /title !quote(!conc('Воспроизведеная матрица сохранена как ',!msave,'.')).
     !ifend
-    do if rowtype(3)='CORR' and rowtype(1)<>'CORR'.
-     do if rowtype(1)='MEAN' and (rowtype(2)='STDDEV' or rowtype(2)='SD').
-      comp vars= vars&*kroneker(vec2,make(n,1,1))+kroneker(vec1,make(n,1,1)).
-     else if rowtype(1)='MIN' and rowtype(2)='MEAN'.
-      comp vars= vars&*kroneker((vec1-vec2)/cmin(vars),make(n,1,1))+kroneker(vec2,make(n,1,1)).
-     else if rowtype(1)='MIN' and (rowtype(2)='STDDEV' or rowtype(2)='SD').
-      comp vars= (vars-kroneker(cmin(vars),make(n,1,1)))&*kroneker(vec2,make(n,1,1))+kroneker(vec1,make(n,1,1)).
-     else if rowtype(1)='MAX' and rowtype(2)='MEAN'.
-      comp vars= vars&*kroneker((vec1-vec2)/cmax(vars),make(n,1,1))+kroneker(vec2,make(n,1,1)).
-     else if rowtype(1)='MAX' and (rowtype(2)='STDDEV' or rowtype(2)='SD').
-      comp vars= (vars-kroneker(cmax(vars),make(n,1,1)))&*kroneker(vec2,make(n,1,1))+kroneker(vec1,make(n,1,1)).
-     else if rowtype(1)='MIN' and rowtype(2)='MAX'.
-      comp vars= vars&*kroneker((vec2-vec1)/(cmax(vars)-cmin(vars)),make(n,1,1)).
-      comp vars= vars+kroneker(vec2-cmax(vars),make(n,1,1)).
-     end if.
-    else if rowtype(3)='COV' and rowtype(1)<>'COV'.
-     do if rowtype(1)='MEAN'.
-      comp vars= vars+kroneker(vec1,make(n,1,1)).
-     else if rowtype(1)='MIN'.
-     comp vars= vars+kroneker(vec1-cmin(vars),make(n,1,1)).
-     else if rowtype(1)='MAX'.
-      comp vars= vars+kroneker(vec1-cmax(vars),make(n,1,1)).
-     end if.
-    end if.
-    save vars /outfile= * /names= vnam.
-    !mscmd.
-   end if.
-  end if.
-end if.
-end matrix.
!ifend
!enddefine.

*/*!KO_FITVAR*/*******************************************************************************.
define !KO_fitvar(cvars= !charend('/') /rvars= !charend('/') /matrix= !charend('/') /adjust= !charend('/') /iter= !charend('/') /msave= !charend('/'))
!if (!iter=!null !or !tail(!iter)<>!null) !then
-do if $casenum=1.
-print /'>ERROR. Неверно задано ITER.'.
-end if.
-exec.
!else
-set mxloops 10000.
-matrix.
-comp ok= 1.
-get mx /file= !matrix /names= cnam /miss= -999.
-comp rowtype= mx(:,1).
-comp varname= mx(:,2).
-comp mx= mx(:,3:ncol(mx)).
-comp vec1= make(1,ncol(mx),0).
-comp vec2= make(1,ncol(mx),0).
-comp rowtype= {rowtype;rowtype(nrow(rowtype));rowtype(nrow(rowtype))}.
-do if rowtype(3)='COV'.
- do if any(rowtype(1)={'MIN','MAX','MEAN'}) and any(rowtype(2)={'STDDEV','SD'}).
-  comp vec1= mx(1,:).
-  comp ssvec= mx(2,:)&**2.
-  comp mx= mx(3:nrow(mx),:).
- else if any(rowtype(1)={'STDDEV','SD'}) and rowtype(2)='COV'.
-  comp ssvec= mx(1,:)&**2.
-  comp mx= mx(2:nrow(mx),:).
- else.
-  comp ok= 0.
-  print /title '>ERROR. В матрице неверно заданы векторы статистик для COV.'.
- end if.
-else if rowtype(3)='CORR'.
- comp ssvec= make(1,ncol(mx),1).
- do if any(rowtype(1)={'MIN','MAX','MEAN'}).
-  comp vec1= mx(1,:).
- else if rowtype(1)<>'CORR'.
-  comp ok= 0.
-  print /title '>ERROR. В матрице 1-й вектор статистик неправилен для CORR.'.
- end if.
- do if any(rowtype(2)={'MAX','MEAN','STDDEV','SD'}) and rowtype(2)<>rowtype(1).
-  comp vec2= mx(2,:).
-  comp mx= mx(3:nrow(mx),:).
- else if rowtype(1)<>'CORR'.
-  comp ok= 0.
-  print /title '>ERROR. В матрице 2-й вектор статистик неправилен для CORR или отсутствует.'.
- end if.
-else if rowtype(2)='SCP' and rowtype(3)='SCP'.
- do if rowtype(1)='SS'.
-  comp ssvec= mx(1,:).
-  comp mx= mx(2:nrow(mx),:).
- else.
-  comp ok= 0.
-  print /title '>ERROR. В матрице SCP не задан вектор SS или есть посторонние векторы.'.
- end if.
-else if rowtype(2)='MCP' and rowtype(3)='MCP'.
- do if rowtype(1)='MS'.
-  comp ssvec= mx(1,:).
-  comp mx= mx(2:nrow(mx),:).
- else.
-  comp ok= 0.
-  print /title '>ERROR. В матрице MCP не задан вектор MS или есть посторонние векторы.'.
- end if.
-else.
- comp ok= 0.
- print /title '>ERROR. В матрице есть векторы неразрешенных статистик, или тип матрицы неясен.'.
-end if.
-do if ok.
- print rowtype(3) /title 'Тип целевой матрицы:' /format= a8.
- get cvars /vari= !cvars /names= cvnam /miss= 0.
- comp ind= 0.
- loop i= 1 to ncol(cvnam).
-  loop i2= 3 to ncol(cnam).
-   do if cnam(i2)=cvnam(i).
-    comp ind= {ind,i2}.
-    break.
-   end if.
-  end loop.
- end loop if i2=ncol(cnam)+1.
- do if i2=ncol(cnam)+1.
-  print /title '>ERROR. Имена некоторых CVARS отсутствуют среди столбцов матрицы.'.
- else.
-  comp ind= ind(2:ncol(ind))-2.
-  comp mx= mx(:,ind).
-  comp vec1= vec1(ind). 
-  comp vec2= vec2(ind). 
-  comp ssvec= ssvec(ind).
-  get rvars /vari= !rvars /names= rvnam.
-  comp ind= 0.
-  comp varname= varname((nrow(varname)-nrow(mx)+1):nrow(varname)).
-  loop i= 1 to ncol(rvnam).
-   loop i2= 1 to nrow(varname).
-    do if varname(i2)=rvnam(i).
-     comp ind= {ind,i2}.
-     break.
-    end if.
-   end loop.
-  end loop if i2=nrow(varname)+1.
-  do if i2=nrow(varname)+1.
-   print /title '>ERROR. Имена некоторых RVARS отсутствуют среди рядов матрицы.'.
-  else.
-   comp mx= mx(ind(2:ncol(ind)),:).
-   comp n= nrow(cvars).
-   do if rowtype(3)='CORR' or rowtype(3)='COV'.
-    comp df= n-1.
-   else if rowtype(3)='MCP'.
-    comp df= n.
-   else.
-    comp df= 1.
-   end if.
-   comp validmx= mx<>-999.
-   comp mx= mx*df.
-   comp ssvec= ssvec*df.
-   do if rowtype(3)='CORR' or rowtype(3)='COV'.
-    comp cvars= cvars-kroneker(csum(cvars)/n,make(n,1,1)).
-    comp rvars= rvars-kroneker(csum(rvars)/n,make(n,1,1)).
-   end if.
-   comp cvars= cvars&*kroneker(sqrt(ssvec/cssq(cvars)),make(n,1,1)).
-   do if rowtype(3)='CORR'.
-    comp rvars= rvars&*kroneker(sqrt(df/cssq(rvars)),make(n,1,1)).
-   end if.
-   loop i= 1 to ncol(cvars).
-    comp ind= 0.
-    loop j= 1 to nrow(mx).
-     do if validmx(j,i).
-      comp ind= {ind,j}.
-     end if.
-    end loop.
-    do if ncol(ind)=1.
-     print cvnam(i) /title '>WARNING. Столбец целевых коэффициентов пуст для переменной:' /format= a8.
-     print /title ' Эта переменная НЕ будет подогнана.' /space= 0.
-    else.
-     comp ind= ind(2:ncol(ind)).
-     comp b= inv(sscp(rvars(:,ind)))*mx(ind,i).
-     comp pre= rvars(:,ind)*b.
-     comp cvars(:,i)= cvars(:,i)-pre.
-     comp ss= ssvec(i)-cssq(pre).
-     do if ss<0.
-      print cvnam(i) /title '>WARNING. Целевая матрица не грамова для переменной:' /format= a8.
-      print /title ' Эта переменная НЕ будет подогнана к коэффициентам.' /space= 0.
-     else.
-      comp vrss= rssq(rvars(:,ind)).
       !if (!adjust<>'NONE') !then
-       comp vcss= kroneker(cssq(rvars(:,ind)),make(n,1,1)).
       !ifend
       !if (!adjust='HSCED1' !or !adjust='HSCED2') !then !let !sign= 'comp s= (cvars(:,i)>=0)-(cvars(:,i)<0)' !let !hsced= '+s&*rsum(c_&*rvars_&**3/vcss_)' !let !vrss_= '+vrss_'
-       comp rvars_= rvars(:,ind)-kroneker(csum(rvars(:,ind))/n,make(n,1,1)).
        !if (!adjust='HSCED2') !then
-        comp rvars_= abs(rvars_)-kroneker(csum(abs(rvars_))/n,make(n,1,1)).
        !ifend
-       comp vrss_= rssq(rvars_).
-       comp vcss_= kroneker(cssq(rvars_),make(n,1,1)).
       !ifend
-      comp vrss= vrss+((vrss!vrss_)=0).
-      loop i2= 1 to !iter.
        !if (!adjust<>'NONE') !then
-        comp cvars(:,i)= cvars(:,i)-csum(cvars(:,i))/n.
        !ifend
-       comp c= kroneker(t(cvars(:,i))*rvars(:,ind),make(n,1,1)).
        !if (!adjust='HSCED1' !or !adjust='HSCED2') !then
-        comp c_= kroneker(t(abs(cvars(:,i)))*rvars_,make(n,1,1)).
        !ifend
        !if (!adjust='NONE') !then
-        comp cvars(:,i)= cvars(:,i)-rsum(c&*rvars(:,ind))/n/vrss.
        !else
-        !sign.
-        comp cvars(:,i)= cvars(:,i)-(rsum(c&*rvars(:,ind)&**3/vcss)!hsced)/(vrss!vrss_).
        !ifend
-       comp cvars(:,i)= cvars(:,i)*sqrt(ss/cssq(cvars(:,i))).
-      end loop.
-      comp cvars(:,i)= pre+cvars(:,i).
-     end if.
-    end if.
-   end loop.
-   release c.
    !if (!adjust<>'NONE') !then
-    release vcss.
    !ifend
    !if (!adjust='HSCED1' !or !adjust='HSCED2') !then
-    release rvars_,vcss_,c_.
    !ifend
-   do if rowtype(3)='CORR' or rowtype(3)='COV'.
-    comp cvars= cvars-kroneker(csum(cvars)/n,make(n,1,1)).
-   end if.
-   comp cvars= cvars&*kroneker(sqrt(ssvec/cssq(cvars)),make(n,1,1)).
-   comp cvcs= csum(cvars).
-   comp rvcs= t(csum(rvars)).
-   comp num= mx*n-kroneker(cvcs,make(nrow(mx),1,1))&*kroneker(rvcs,make(1,ncol(mx),1)).
-   comp den= kroneker(ssvec*n-cvcs&**2,make(nrow(mx),1,1))&*kroneker(t(cssq(rvars)*n)-rvcs&**2,make(1,ncol(mx),1)).
-   comp mx= num/sqrt(den).
-   comp num= (t(rvars)*cvars)*n-kroneker(cvcs,make(nrow(mx),1,1))&*kroneker(rvcs,make(1,ncol(mx),1)).
-   comp mx= abs(mx-num/sqrt(den))&*validmx.
-   print (msum(mx)/msum(validmx)) /title 'Общая недостигнутость целевой матрицы:' /format= f20.15.
-   print t(cmax(mx)) /title 'Максимальная постолбцовая недостигнутость целевой матрицы:' /rnames= cvnam /format= f18.15.
    !if (!msave<>!null) !then !let !mscmd= !conc('save {rowtype((nrow(rowtype)-nrow(mx)-1):(nrow(rowtype)-2)),t(rvnam),mx} /outfile=',!msave,' /names= cnam /strings= rowtype_ varname_')
-    comp mx= t(rvars)*cvars/df.
-    comp cnam= {'rowtype_','varname_',cvnam}.
-    print /title !quote(!conc('Воспроизведеная матрица сохранена как ',!msave,'.')).
    !ifend
-   do if rowtype(3)='CORR' and rowtype(1)<>'CORR'.
-    do if rowtype(1)='MEAN' and (rowtype(2)='STDDEV' or rowtype(2)='SD').
-     comp cvars= cvars&*kroneker(vec2,make(n,1,1))+kroneker(vec1,make(n,1,1)).
-    else if rowtype(1)='MIN' and rowtype(2)='MEAN'.
-     comp cvars= cvars&*kroneker((vec1-vec2)/cmin(cvars),make(n,1,1))+kroneker(vec2,make(n,1,1)).
-    else if rowtype(1)='MIN' and (rowtype(2)='STDDEV' or rowtype(2)='SD').
-     comp cvars= (cvars-kroneker(cmin(cvars),make(n,1,1)))&*kroneker(vec2,make(n,1,1))+kroneker(vec1,make(n,1,1)).
-    else if rowtype(1)='MAX' and rowtype(2)='MEAN'.
-     comp cvars= cvars&*kroneker((vec1-vec2)/cmax(cvars),make(n,1,1))+kroneker(vec2,make(n,1,1)).
-    else if rowtype(1)='MAX' and (rowtype(2)='STDDEV' or rowtype(2)='SD').
-     comp cvars= (cvars-kroneker(cmax(cvars),make(n,1,1)))&*kroneker(vec2,make(n,1,1))+kroneker(vec1,make(n,1,1)).
-    else if rowtype(1)='MIN' and rowtype(2)='MAX'.
-     comp cvars= cvars&*kroneker((vec2-vec1)/(cmax(cvars)-cmin(cvars)),make(n,1,1)).
-     comp cvars= cvars+kroneker(vec2-cmax(cvars),make(n,1,1)).
-    end if.
-   else if rowtype(3)='COV' and rowtype(2)<>'COV'.
-    do if rowtype(1)='MEAN'.
-     comp cvars= cvars+kroneker(vec1,make(n,1,1)).
-    else if rowtype(1)='MIN'.
-    comp cvars= cvars+kroneker(vec1-cmin(cvars),make(n,1,1)).
-    else if rowtype(1)='MAX'.
-     comp cvars= cvars+kroneker(vec1-cmax(cvars),make(n,1,1)).
-    end if.
-   end if.
-   save cvars /outfile= * /names= cvnam.
-   !mscmd.
-  end if.
- end if.
-end if.
-end matrix.
!ifend
!enddefine.
